package com.zx.dataservice.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.zx.dataservice.config.ActiveConfig;
import com.zx.dataservice.options.DataOptions;
import com.zx.dataservice.options.WSOptions;
import com.zx.dataservice.options.ZXOptions;
import com.zx.dataservice.pojo.StockRestPojo;
import com.zx.dataservice.redismessage.util.RedisUtil;
import com.zx.dataservice.service.ChoiceHisService;
import com.zx.dataservice.service.ChoiceService;
import com.zx.dataservice.utils.DateUtils;
import com.zx.dataservice.vo.StockRestRedisVO;
import com.zx.dataservice.vo.StockRestVO;
import com.zx.dataservice.vo.StockVO;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.TimeUnit;

@Controller
@RequestMapping({"/admin/"})
public class CallBackController {

    private static Logger LOG = LoggerFactory.getLogger(CallBackController.class);

    @Autowired
    private ChoiceHisService choiceHisService;

    @Autowired
    private RedisUtil redisUtil;

    @Autowired
    private ChoiceService choiceService;

    @GetMapping("/t1")
    @ResponseBody
    public String quantCallBack(String code){
        String url1 = "https://api.huobi.pro/market/history/kline?period=1day&size=200&symbol=btcusdt";
        String ur2 = "https://status.huobigroup.com/api/v2/summary.json";
        String url = "https://api.huobi.pro/market/history/kline?period=1day&size=200&symbol=btcusdt";
        String s1 = "";
        try {
//            String wssurl1 = "ws://192.168.1.101:8088/websocket/zxdata9876541+";
//            String wssurl1 = "ws://101.32.215.72:8080/data_server_java/websocket/zxdata9876541+";
// http://qwer16888.vip/stock2coin/ws/test/start.do
//            String s = HttpRequest.doGet(url, "");
//            WsClient myClient = new WsClient(new URI(wssurl1));
//            myClient.connect();
            // 判断是否连接成功，未成功后面发送消息时会报错
//            while (!myClient.getReadyState().equals(WebSocket.READYSTATE.OPEN)) {
//                System.out.println("连接中···请稍后");
//                Thread.sleep(1000);
//            }
//            myClient.send("123");
//            System.out.println("发送成功");

//            new WebSocketController().sendSysMsg("zxdata987654+","sss");

        } catch (Exception e) {
            return e.toString();
//            e.printStackTrace();
//            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
//        Request executeRequest = new Request.Builder()
//                .url(url)
//                .addHeader("Content-Type", "application/x-www-form-urlencoded")
//                .build();
//        String str = ConnectionFactory.execute(executeRequest);
        return "true";
    }



    @GetMapping("/test")
    @ResponseBody
    public boolean test(String code){
        try {

//            QuantUtil quantUtil = new QuantUtil();
////        System.out.println("初始化东方财富");
//            quantUtil.init();
////        //调用登录函数
//        quantUtil.start();

        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }

    @GetMapping("/updateZX")
    @ResponseBody
    public boolean updateZX(String code){
        try {
            List<Record> records = Db.use("gp").find("select config_key,config_value from sys_config ");
            for (Record record:records) {
                ZXOptions.set(record.getStr("config_key"),record.getStr("config_value"));
            }

            List<Record> recordws = Db.use("gp").find("select wskey,wsvalue,wsname from ws_config ");
            for (Record record:recordws) {
                WSOptions.set(record.getStr("wskey"),record.getStr("wsname")+"_"+record.getStr("wsvalue"));
            }
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }

    /*
    修改  风控后需要调此方法
     */
    @GetMapping("/updateRisk")
    @ResponseBody
    public boolean updateRisk(String code){
        try {
            ActiveConfig.activeRisk();
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }

    /**
     * 历史风控数据维护
     * @param code
     * @return
     */
    @GetMapping("/updateHis")
    @ResponseBody
    public boolean updateHis(String code){
        try {
            choiceHisService.toAnalysisHistData();
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }


    @GetMapping("/start")
    @ResponseBody
    public boolean start(String code){
        try {

        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }
    @GetMapping("/tows")
    @ResponseBody
    public boolean tows(String code){
        try {
            ZXOptions.set("isold",code);
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }



    @GetMapping("/sendws")
    @ResponseBody
    public boolean sendws(String code){
        try {
            choiceService.analysisDataTask();
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }

    @GetMapping("/showWs")
    @ResponseBody
    public String showWs(String code){
        String s = "";
        try {
             s = new WebSocketController().showWs(code);
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return s;
    }


    @RequestMapping({"showRedis.do"})
    @ResponseBody
    public String showRedis(String key, String code) {
        String redisData = "";
        try {
            if (StringUtils.isBlank(key)) {
                key = "data_stock";
            }
            String redisKey = String.format(key);
            redisData = redisUtil.getItem(redisKey);
            if (StringUtils.isNotBlank(code)) {
                List<StockVO> stockRedisList = new ArrayList<>();
                if (StringUtils.isNotEmpty(redisData) && !("[]".equals(redisData))) {
                    stockRedisList = JSONArray.parseArray(redisData, StockVO.class);
                    Iterator<StockVO> iteratorRedis = stockRedisList.iterator();
                    while (iteratorRedis.hasNext()) {
                        StockVO stockRedis = iteratorRedis.next();
                        if (code.equals(stockRedis.getCode())) {
                            redisData = JSON.toJSONString(stockRedis);
                            break;
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            return e.toString();
        }
        new WebSocketController().sendSysMsg("hydata201226",redisData);
        return redisData;
    }

    private int randomInt() {
        int max = 10000;
        int min = 5000;
        int ran = (int) (Math.random() * (max - min) + min);
        return ran;
    }
    @GetMapping("/testr")
    @ResponseBody
    public String testr(String key1){

        String redisKeystock = String.format("stock");
        List<String> itemLikeListstock = redisUtil.getItemLikeList(redisKeystock);
//        List<StockVO> stockRedisListStock = new ArrayList<>();
        ConcurrentHashMap<String, StockVO> stockRedisListStock = new ConcurrentHashMap<>();
        for (String str:itemLikeListstock) {
            StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
            stockRedisListStock.put(stockVO.getCode(),stockVO);
        }
        String redisKeybond = String.format("bond");
        List<String> itemLikeListbond = redisUtil.getItemLikeList(redisKeybond);
//        List<StockVO> stockRedisListBond = new ArrayList<>();
        ConcurrentHashMap<String, StockVO> stockRedisListBond = new ConcurrentHashMap<>();
        for (String str:itemLikeListbond) {
            StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
            stockRedisListBond.put(stockVO.getCode(),stockVO);
        }
        for (String key2 : WSOptions.keySet()) {
            if(!(new WebSocketController().showWs("").contains(key2+";"))){ // 只推送在线的服务器 加符号 是 防止 类似的key
                continue;
            }
//            List<StockVO> stockRedisListALL = new ArrayList<>();
            ConcurrentHashMap<String, StockVO> stockRedisListALL = new ConcurrentHashMap<>();

            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("gp")&&(!WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase()))){
                stockRedisListALL.putAll(stockRedisListStock);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("zq")&&(!WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase()))){
                stockRedisListALL.putAll(stockRedisListBond);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("zs")||WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase())) {
                String redisKeyindex = "index_" + WSOptions.get(key2).split("_")[0] + "_";  // 对应的风控 redis  index_sl_XXX.SH
                List<String> itemLikeListindexk = redisUtil.getItemLikeList(redisKeyindex);
//                List<StockVO> stockRedisListWS = new ArrayList<>();
                ConcurrentHashMap<String, StockVO> stockRedisListWS = new ConcurrentHashMap<>();
                for (String str : itemLikeListindexk) {
                    StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
                    stockRedisListWS.put(stockVO.getCode(),stockVO);
                }
                stockRedisListALL.putAll(stockRedisListWS);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase())) { // 推送所有
                stockRedisListALL.putAll(stockRedisListStock);
                stockRedisListALL.putAll(stockRedisListBond);
            }
            new WebSocketController().sendSysMsg(key2, JSON.toJSONString(stockRedisListALL));
        }

        return "true" ;
    }


    @GetMapping("/testq")
    @ResponseBody
    public boolean testq(String key1){
        try {
            redisUtil.deleteItemLike("stock");
            redisUtil.deleteItemLike("bond");
            redisUtil.deleteItemLike("index");
            List<Record> records = Db.find("select id,stock_code from stock where stock_or_bond = 0  and stock_plate <>'5' ");
            List<Record> recordsb = Db.find("select id,stock_code from stock where stock_or_bond = 1 ");
            List<Record> recordsi = Db.find("select id,stock_code from stock where stock_or_bond = 0  and stock_plate = '5' ");

            for (int ii = 10; ii < 20; ii++) {

                System.out.println("操作开始**"+DateUtils.getCurrentTimeSSS()+"**");
                int i = 10000 ;
                for (Record r:records) {
                    i++;
                    StockRestRedisVO stockRestRedisVO = new StockRestRedisVO();
                    stockRestRedisVO.setCode(r.getStr("stock_code").toUpperCase());
                    stockRestRedisVO.setNowPrice(ii+""+i+"");
                    stockRestRedisVO.setChange(ii+""+i+"");
                    stockRestRedisVO.setHcrate(ii+""+i+"");

                    stockRestRedisVO.setHighlimit(ii+""+i+"");
                    stockRestRedisVO.setLowlimit(ii+""+i+"");


                    stockRestRedisVO.setBuy1(ii+""+i+"");
                    stockRestRedisVO.setBuy2(ii+""+i+"");
                    stockRestRedisVO.setBuy3(ii+""+i+"");
                    stockRestRedisVO.setBuy4(ii+""+i+"");
                    stockRestRedisVO.setBuy5(ii+""+i+"");

                    stockRestRedisVO.setSell1(ii+""+i+"");
                    stockRestRedisVO.setSell2(ii+""+i+"");
                    stockRestRedisVO.setSell3(ii+""+i+"");
                    stockRestRedisVO.setSell4(ii+""+i+"");
                    stockRestRedisVO.setSell5(ii+""+i+"");

                    stockRestRedisVO.setBuy1_num(ii+""+i+"");
                    stockRestRedisVO.setBuy2_num(ii+""+i+"");
                    stockRestRedisVO.setBuy3_num(ii+""+i+"");
                    stockRestRedisVO.setBuy4_num(ii+""+i+"");
                    stockRestRedisVO.setBuy5_num(ii+""+i+"");

                    stockRestRedisVO.setSell1_num(ii+""+i+"");
                    stockRestRedisVO.setSell2_num(ii+""+i+"");
                    stockRestRedisVO.setSell3_num(ii+""+i+"");
                    stockRestRedisVO.setSell4_num(ii+""+i+"");
                    stockRestRedisVO.setSell5_num(ii+""+i+"");
                    redisUtil.saveItem("stock_"+r.get("stock_code"),JSON.toJSONString(stockRestRedisVO), 10, TimeUnit.DAYS);
                }

                int j = 10000 ;
                for (Record r:recordsb) {
                    j++;
                    StockRestRedisVO stockRestRedisVO = new StockRestRedisVO();
                    stockRestRedisVO.setCode(r.getStr("stock_code").toUpperCase());
                    stockRestRedisVO.setNowPrice(ii+""+j+"");
                    stockRestRedisVO.setChange(ii+""+j+"");
                    stockRestRedisVO.setHcrate(ii+""+j+"");

                    stockRestRedisVO.setHighlimit(ii+""+j+"");
                    stockRestRedisVO.setLowlimit(ii+""+j+"");


                    stockRestRedisVO.setBuy1(ii+""+j+"");
                    stockRestRedisVO.setBuy2(ii+""+j+"");
                    stockRestRedisVO.setBuy3(ii+""+j+"");
                    stockRestRedisVO.setBuy4(ii+""+j+"");
                    stockRestRedisVO.setBuy5(ii+""+j+"");

                    stockRestRedisVO.setSell1(ii+""+j+"");
                    stockRestRedisVO.setSell2(ii+""+j+"");
                    stockRestRedisVO.setSell3(ii+""+j+"");
                    stockRestRedisVO.setSell4(ii+""+j+"");
                    stockRestRedisVO.setSell5(ii+""+j+"");

                    stockRestRedisVO.setBuy1_num(ii+""+j+"");
                    stockRestRedisVO.setBuy2_num(ii+""+j+"");
                    stockRestRedisVO.setBuy3_num(ii+""+j+"");
                    stockRestRedisVO.setBuy4_num(ii+""+j+"");
                    stockRestRedisVO.setBuy5_num(ii+""+j+"");

                    stockRestRedisVO.setSell1_num(ii+""+j+"");
                    stockRestRedisVO.setSell2_num(ii+""+j+"");
                    stockRestRedisVO.setSell3_num(ii+""+j+"");
                    stockRestRedisVO.setSell4_num(ii+""+j+"");
                    stockRestRedisVO.setSell5_num(ii+""+j+"");
                    redisUtil.saveItem("bond_"+r.get("stock_code"),JSON.toJSONString(stockRestRedisVO), 10, TimeUnit.DAYS);
                }

                int k = 10000 ;
                for (Record r:recordsi) {
                    k++;
                    StockRestRedisVO stockRestRedisVO = new StockRestRedisVO();
                    stockRestRedisVO.setCode(r.getStr("stock_code").toUpperCase());
                    stockRestRedisVO.setNowPrice(ii+""+k + "");
                    stockRestRedisVO.setChange(ii+""+k + "");
                    stockRestRedisVO.setHcrate(ii+""+k + "");

                    stockRestRedisVO.setHighlimit(ii+""+k + "");
                    stockRestRedisVO.setLowlimit(ii+""+k + "");


                    stockRestRedisVO.setBuy1(ii+""+k + "");
                    stockRestRedisVO.setBuy2(ii+""+k + "");
                    stockRestRedisVO.setBuy3(ii+""+k + "");
                    stockRestRedisVO.setBuy4(ii+""+k + "");
                    stockRestRedisVO.setBuy5(ii+""+k + "");

                    stockRestRedisVO.setSell1(ii+""+k + "");
                    stockRestRedisVO.setSell2(ii+""+k + "");
                    stockRestRedisVO.setSell3(ii+""+k + "");
                    stockRestRedisVO.setSell4(ii+""+k + "");
                    stockRestRedisVO.setSell5(ii+""+k + "");

                    stockRestRedisVO.setBuy1_num(ii+""+k + "");
                    stockRestRedisVO.setBuy2_num(ii+""+k + "");
                    stockRestRedisVO.setBuy3_num(ii+""+k + "");
                    stockRestRedisVO.setBuy4_num(ii+""+k + "");
                    stockRestRedisVO.setBuy5_num(ii+""+k + "");

                    stockRestRedisVO.setSell1_num(ii+""+k + "");
                    stockRestRedisVO.setSell2_num(ii+""+k + "");
                    stockRestRedisVO.setSell3_num(ii+""+k + "");
                    stockRestRedisVO.setSell4_num(ii+""+k + "");
                    stockRestRedisVO.setSell5_num(ii+""+k + "");

                    int f = 0;
                    for (String key2 : WSOptions.keySet()) {  // 所有的需要推送的客户
                        // 如果该股票需要风控
                        if (DataOptions.get("keyall").contains((WSOptions.get(key2).split("_")[0] + "_" + stockRestRedisVO.getCode().toUpperCase()))) {  // 存在该用户的该股票的风控 记录
                            for (String key : DataOptions.keySet()) {  // 所有的需要风控的 客户  BTC_BTC_hy  LTC_hy  000001.SZ_hy  LTC_test  test_BTC_BTC
                                // 风控 逻辑
                                if ("keyall".equals(key)) {
                                    continue;
                                }
                                if (key.contains((WSOptions.get(key2).split("_")[0] + "_" + stockRestRedisVO.getCode().toUpperCase()))) {// 存在该股票的风控  LTC_hy . contains (LTC)
                                    f++;
                                    StockRestRedisVO stockRestRedisVOf = new StockRestRedisVO();
                                    stockRestRedisVOf.setCode(stockRestRedisVO.getCode());
                                    stockRestRedisVOf.setNowPrice(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setChange(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setHcrate(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setHighlimit(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setLowlimit(ii+""+k + "999"+f);

                                    stockRestRedisVOf.setBuy1(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy2(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy3(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy4(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy5(ii+""+k + "999"+f);

                                    stockRestRedisVOf.setSell1(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell2(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell3(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell4(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell5(ii+""+k + "999"+f);

                                    stockRestRedisVOf.setBuy1_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy2_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy3_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy4_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setBuy5_num(ii+""+k + "999"+f);

                                    stockRestRedisVOf.setSell1_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell2_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell3_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell4_num(ii+""+k + "999"+f);
                                    stockRestRedisVOf.setSell5_num(ii+""+k + "999"+f);

                                    redisUtil.saveItem("index_" + WSOptions.get(key2).split("_")[0] + "_" + r.get("stock_code"), JSON.toJSONString(stockRestRedisVOf), 10, TimeUnit.DAYS);
                                    break;
                                }
                            }
                        } else {
                            redisUtil.saveItem("index_" + WSOptions.get(key2).split("_")[0] + "_" + r.get("stock_code"), JSON.toJSONString(stockRestRedisVO), 10, TimeUnit.DAYS);

                        }

                    }
                }
                System.out.println("操作结束**"+DateUtils.getCurrentTimeSSS()+"**"+k);
                Thread.sleep(1000);
            }


        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }

        return true;
    }


    @GetMapping("/remMap")
    @ResponseBody
    public boolean remMap2(String key){
        try {

        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }


    @GetMapping("/remWSKey")
    @ResponseBody
    public boolean remWSKey(String key){
        try {
            new WebSocketController().remWSKey(key);
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }



    @GetMapping("/testis")
    @ResponseBody
    public boolean testis(String key){
        try {
            final String[] webArr = ZXOptions.get("ws.key").split(";");//websocket key
            for (int j = 0; j < webArr.length; j++) {
                new WebSocketController().sendSysMsg(webArr[j],key);
            }
        } catch (Exception e) {
            if(e.toString().length()>500){                LOG.error(e.toString().substring(0,450));            }else {                LOG.error(e.toString());            }
        }
        return true;
    }





}
