package com.zx.dataservice.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.zx.dataservice.controller.WebSocketController;
import com.zx.dataservice.options.DataOptions;
import com.zx.dataservice.options.WSOptions;
import com.zx.dataservice.redismessage.util.RedisUtil;
import com.zx.dataservice.service.ChoiceHisService;
import com.zx.dataservice.service.ChoiceService;
import com.zx.dataservice.utils.BigdecimalUtil;
import com.zx.dataservice.utils.DateUtils;
import com.zx.dataservice.utils.WorkingDayUtil;
import com.zx.dataservice.vo.StockVO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

@Service
public class ChoiceServiceImpl implements ChoiceService {

    @Autowired
    private RedisUtil redisUtil;

    @Override
    public void analysisDataTask() {
        String redisKeystock = String.format("stock");
        List<String> itemLikeListstock = redisUtil.getItemLikeList(redisKeystock);
//        List<StockVO> stockRedisListStock = new ArrayList<>();
        ConcurrentHashMap<String, StockVO> stockRedisListStock = new ConcurrentHashMap<>();
        for (String str:itemLikeListstock) {
            StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
            stockRedisListStock.put(stockVO.getCode(),stockVO);
        }
        String redisKeybond = String.format("bond");
        List<String> itemLikeListbond = redisUtil.getItemLikeList(redisKeybond);
//        List<StockVO> stockRedisListBond = new ArrayList<>();
        ConcurrentHashMap<String, StockVO> stockRedisListBond = new ConcurrentHashMap<>();
        for (String str:itemLikeListbond) {
            StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
            stockRedisListBond.put(stockVO.getCode(),stockVO);
        }
        for (String key2 : WSOptions.keySet()) {
            if(!(new WebSocketController().showWs("").contains(key2+";"))){ // 只推送在线的服务器 加符号 是 防止 类似的key
                continue;
            }
//            List<StockVO> stockRedisListALL = new ArrayList<>();
            ConcurrentHashMap<String, StockVO> stockRedisListALL = new ConcurrentHashMap<>();

            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("gp")&&(!WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase()))){
                stockRedisListALL.putAll(stockRedisListStock);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("zq")&&(!WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase()))){
                stockRedisListALL.putAll(stockRedisListBond);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("zs")||WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase())) {
                String redisKeyindex = "index_" + WSOptions.get(key2).split("_")[0] + "_";  // 对应的风控 redis  index_sl_XXX.SH
                List<String> itemLikeListindexk = redisUtil.getItemLikeList(redisKeyindex);
//                List<StockVO> stockRedisListWS = new ArrayList<>();
                ConcurrentHashMap<String, StockVO> stockRedisListWS = new ConcurrentHashMap<>();
                for (String str : itemLikeListindexk) {
                    StockVO stockVO = JSONObject.parseObject(str, StockVO.class);
                    stockRedisListWS.put(stockVO.getCode(),stockVO);
                }
                stockRedisListALL.putAll(stockRedisListWS);
            }
            if(WSOptions.get(key2).split("_")[1].toLowerCase().contains("ALL".toLowerCase())) { // 推送所有
                stockRedisListALL.putAll(stockRedisListStock);
                stockRedisListALL.putAll(stockRedisListBond);
            }
            if(stockRedisListALL!=null&&stockRedisListALL.size()>0){
                new WebSocketController().sendSysMsg(key2, JSON.toJSONString(stockRedisListALL));
            }
        }

    }
}
